#!/usr/bin/env ruby

##
## creatable - ơ֥ɤ߹ǲùƥץ졼ȤǽϤ
##

require 'yaml'
require 'erb'


##
## ᥤץɽ饹
##
## Ȥ
##  main = MainProgram.new()
##  output = main.execute(ARGV)
##  print output if output
##
class MainProgram

  def execute(argv=ARGV)
    # ޥɥץβ
    options, properties = _parse_options(ARGV)
    return usage() if options[:help]
    raise "ƥץ졼ȤꤵƤޤ" unless options[:template]

    # ǡեɤ߹ࡣʸ϶Ÿ롣
    s = ''
    while line = gets()
      s << line.gsub(/([^\t]{8})|([^\t]*)\t/n){[$+].pack("A8")}
    end
    doc = YAML.load(s)

    # ɤ߹ǡù
    manipulator = Manipulator.new(doc)
    manipulator.manipulate()

    # ƥץ졼Ȥ򸡺
    t = options[:template]
    if test(?f, t)
      template = t
    elsif ENV['CREATABLE_PATH']
      path_list = ENV['CREATABLE_PATH'].split(File::PATH_SEPARATOR)
      template = path_list.find { |path| test(?f, "#{path}/#{t}") }
    end
    raise "'#{t}': ƥץ졼ȤĤޤ" unless template
    
    # ƥץ졼Ȥɤ߹ǽϤ
    s = File.read(template)
    trim_mode = '>'        # '%>' ǽԤǤϲԤϤʤ
    erb = ERB.new(s, $SAFE, trim_mode)
    if options[:multiple]  # ʣեؽ
      doc['tables'].each do |table|
        context = { 'table' => table, 'properties' => properties }
        output = _eval_erb(erb, context)
        filename = context[:output_filename]   # ϥե̾
        filename = options[:directory] + "/" + filename if options[:directory]
        File.open(filename, 'w') do |f|
          f.write(output)
          $stderr.puts "generated: #{filename}"
        end if filename
      end
      output = nil
    else                   # ɸϤؽ
      context = { 'tables' => doc['tables'], 'properties' => properties }
      output = _eval_erb(erb, context)
    end
    return output
  end

  private

  ## ƥץ졼ȤŬѤ롣
  def _eval_erb(__erb, context)
    # Τ褦ERB#result()¹Ԥ᥽åɤѰդȡ
    # ɬפѿʤξʤcontextˤƥץ졼ȤϤ
    # ɬפʥѿϤʤƤ褦ˤʤ롣
    return __erb.result(binding())
  end

  ## إץå
  def usage()
     s = ''
     s << "Usage: ruby creatable.rb [-h] [-m] -f template datafile.yaml [...]\n"
     s << "  -h          : إ\n"
     s << "  -m          : multiple output file\n"
     s << "  -f template : ƥץ졼ȤΥե̾\n"
     return s
  end

  ## ޥɥץ󤪤ӥƥץ졼ȥץѥƥϤ
  def _parse_options(argv)
    options = {}
    properties = {}
    while argv[0] && argv[0][0] == ?-
      opt = argv.shift
      if opt =~ /^--(.*)/
        # ƥץ졼ȥץѥƥ
        param_str = $1
        if param_str =~ /\A([-\w]+)=(.*)/
          key, value = $1, $2
        else
          key, value = param_str, true
        end
        properties[key] = value
      else
        # ޥɥץ
        case opt
        when '-h'      # إ
          options[:help] = true
        when '-f'      # ƥץ졼̾
          arg = argv.shift
          raise "-f: ƥץ졼̾ꤷƤ" unless arg
          options[:template] = arg
        when '-m'   # ơ֥뤴Ȥνϥե
          options[:multiple] = true
        when '-d'   # ǥ쥯ȥ
          arg = argv.shift
          raise "-d: ǥ쥯ȥ̾ꤷƤ" unless arg
          options[:directory] = arg
        else
          raise "#{opt}: ޥɥץ󤬴ְäƤޤ"
        end
      end
    end
    return options, properties
  end

end


##
## ե뤫ɤ߹ǡåù륯饹
##
## Ȥ
##   doc = YAML.load(file)
##   manipulator = Manipulator.new()
##   manipulator.manipulate(doc)
##
class Manipulator

  def initialize(doc)
    @defaults = doc['defaults'] || {}
    @tables   = doc['tables']   || []
  end

  ## ե뤫ɤ߹ǡ
  def manipulate()
    
    # ֥̾פ Hash 
    default_columns = {}
    @defaults['columns'].each do |column|
      colname = column['name']
      raise "̾ޤ" unless colname
      raise "#{colname}: ̾ʣƤޤ" if default_columns[colname]
      default_columns[colname] = column
    end if @defaults['columns']

    # ơ֥Υåͤꤹ
    tablenames = {}
    @tables.each do |table|
      tblname = table['name']
      raise "ơ֥̾ޤ" unless tblname
      raise "#{tblname}: ơ֥̾ʣƤޤ" if tablenames[tblname]
      tablenames[tblname] = true
      colnames = {}
      table['columns'].each do |column|
        colname = column['name']
        raise "#{tblname}: ̾ޤ" unless colname
        raise "#{tblname}.#{colname}: ̾ʣƤޤ" if colnames[colname]
        colnames[colname] = true
        # Υǥեͤ
        default_column = default_columns[colname]
        default_column.each do |key, val|
          column[key] = val unless column.key?(key)
        end if default_column
        # फơ֥ؤΥ󥯤
        column['table'] = table
        # ǻȤƤ륫Ρǡȥ򥳥ԡ
        if (ref_column = column['ref']) != nil
          column['type']    = ref_column['type']
          column['width'] ||= ref_column['width']  if ref_column.key?('width')
        end
      end if table['columns']
    end
  end

end


## ᥤץ¹
main = MainProgram.new
output = main.execute(ARGV)
print output if output
